# syssetup

This system was created to allow of easy recreation or restoration of a existing system. This is not a backup application, nor does it create a image in the sense of a full disk image. It creates a snapshot of the current system configuration and installed packages. Once this information is collected it is packaged into standalone self extracting restore archive. It does this by copying your /etc folder and generating a list of installed programs via the package manager on the system. These are then packaged into executable you can copy and run on another system. Great for duplicating a say a raspberry pi configuration. Works well for VPS systems as well, especially when you just need to do a clean reinstall.

# Scripts

check.bash - checks if makeself is installed. Can be installed via normal methods or via this script
os_probe.bash - checks if we are on a debian or arch based distro via looking for apt or pacman
restore.*.bash - these are scripts specific to debian or arch
bootstrap.wrt.ash - Specifically for OpenWRT, made specifically to be compatable with bustbox's ash shell. It will check for and if needed install bash before running the rest.
syssetup.bash - The main program 
test.bash - Some file I was using to test something, you can ignore it

# Plans

To add flatpak support for making it more usable for desktops. Also at one point create a custom replacement for makeself thats specific to this script. 

# Notes Oct 11 2023

Well in a attempt to move my own VPS to another I teseted the script. Found a bug where apt didn't have needed permissions. Thats been fixed in the dev version. Now I need to find a way to handle packages that where installed manaully via a downloaded deb file. Aside from some form detection for manually installed packages. 

# Special Thanks 

To the fine folks that created codeium(Link below). The autosuggest / autocomplete features make things allot easier and save me a ton of typing. Having an AI that can function as an assistant is a wonderful thing. 

[![built with Codeium](https://codeium.com/badges/main)](https://codeium.com)